<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.adj.incore.tree;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.IOException;<a name="line.36"></a>
<FONT color="green">037</FONT>    <a name="line.37"></a>
<FONT color="green">038</FONT>    import ch.javasoft.bitset.IBitSet;<a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.metabolic.efm.column.AdjCandidates;<a name="line.39"></a>
<FONT color="green">040</FONT>    import ch.javasoft.metabolic.efm.column.Column;<a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.metabolic.efm.memory.SortableMemory;<a name="line.41"></a>
<FONT color="green">042</FONT>    <a name="line.42"></a>
<FONT color="green">043</FONT>    public interface Root&lt;T /*traversing token*/&gt; {<a name="line.43"></a>
<FONT color="green">044</FONT>            /**<a name="line.44"></a>
<FONT color="green">045</FONT>             * Returns the root for the tree containing the negative columns that are<a name="line.45"></a>
<FONT color="green">046</FONT>             * discarded after this iteration step.<a name="line.46"></a>
<FONT color="green">047</FONT>             */<a name="line.47"></a>
<FONT color="green">048</FONT>            Node&lt;T&gt; neg();<a name="line.48"></a>
<FONT color="green">049</FONT>            /**<a name="line.49"></a>
<FONT color="green">050</FONT>             * Returns the root for the tree containing the positive columns that are<a name="line.50"></a>
<FONT color="green">051</FONT>             * retained after this iteration step.<a name="line.51"></a>
<FONT color="green">052</FONT>             */<a name="line.52"></a>
<FONT color="green">053</FONT>            Node&lt;T&gt; pos();<a name="line.53"></a>
<FONT color="green">054</FONT>            <a name="line.54"></a>
<FONT color="green">055</FONT>            /**<a name="line.55"></a>
<FONT color="green">056</FONT>             * Filters the adjacency candidates contained in &lt;code&gt;adjacentPairs&lt;/code&gt;<a name="line.56"></a>
<FONT color="green">057</FONT>             * and keeps only those that pass the adjacency test.<a name="line.57"></a>
<FONT color="green">058</FONT>             * <a name="line.58"></a>
<FONT color="green">059</FONT>             * @param token                         the traversing token<a name="line.59"></a>
<FONT color="green">060</FONT>             * @param nodeA                         the first leaf node, source of columns used to <a name="line.60"></a>
<FONT color="green">061</FONT>             *                                                      create the adjacency candidates<a name="line.61"></a>
<FONT color="green">062</FONT>             * @param nodeB                         the second leaf node, source of columns used to <a name="line.62"></a>
<FONT color="green">063</FONT>             *                                                      create the adjacency candidates<a name="line.63"></a>
<FONT color="green">064</FONT>             * @param filterCutPattern      the pattern representing the common bits of all<a name="line.64"></a>
<FONT color="green">065</FONT>             *                                                      adjacency candidates<a name="line.65"></a>
<FONT color="green">066</FONT>             * @param posCols                       positive columns that are retained after this<a name="line.66"></a>
<FONT color="green">067</FONT>             *                                                      iteration step, but not lying in the hyperplane<a name="line.67"></a>
<FONT color="green">068</FONT>             * @param zeroCols                      zero columns that are retained after this<a name="line.68"></a>
<FONT color="green">069</FONT>             *                                                      iteration step, lying in the hyperplane<a name="line.69"></a>
<FONT color="green">070</FONT>             * @param negCols                       negative columns that are discarded after this<a name="line.70"></a>
<FONT color="green">071</FONT>             *                                                      iteration step, not lying in the hyperplane<a name="line.71"></a>
<FONT color="green">072</FONT>             * @param adjacentPairs         the candidate pairs, possibly adjacent<a name="line.72"></a>
<FONT color="green">073</FONT>             * @throws IOException  if an i/o exception occurs, for instance since<a name="line.73"></a>
<FONT color="green">074</FONT>             *                                              columns are stored in files<a name="line.74"></a>
<FONT color="green">075</FONT>             */<a name="line.75"></a>
<FONT color="green">076</FONT>            void filterAdjacentPairs(T token, Node&lt;T&gt; nodeA, Node&lt;T&gt; nodeB, IBitSet filterCutPattern, SortableMemory&lt;Column&gt; posCols, SortableMemory&lt;Column&gt; zeroCols, SortableMemory&lt;Column&gt; negCols, AdjCandidates&lt;Column&gt; adjacentPairs) throws IOException;<a name="line.76"></a>
<FONT color="green">077</FONT>            <a name="line.77"></a>
<FONT color="green">078</FONT>            /**<a name="line.78"></a>
<FONT color="green">079</FONT>             * Returns true if this recursion level should be entered, and false if the<a name="line.79"></a>
<FONT color="green">080</FONT>             * subtrees specified by &lt;code&gt;nodeA&lt;/code&gt; and &lt;code&gt;nodeB&lt;/code&gt; cannot<a name="line.80"></a>
<FONT color="green">081</FONT>             * bear adjacent rays. After the recursion, <a name="line.81"></a>
<FONT color="green">082</FONT>             * {@link #leave(Object, Node, Node) leave(..)} must be called to free <a name="line.82"></a>
<FONT color="green">083</FONT>             * resources that might have been allocated. If this method returns false,<a name="line.83"></a>
<FONT color="green">084</FONT>             * &lt;code&gt;leave(..)&lt;/code&gt; must not be called. <a name="line.84"></a>
<FONT color="green">085</FONT>             * <a name="line.85"></a>
<FONT color="green">086</FONT>             * @param token         the traversing token<a name="line.86"></a>
<FONT color="green">087</FONT>             * @param nodeA         node of the first tree to traverse<a name="line.87"></a>
<FONT color="green">088</FONT>             * @param nodeB         node of the second tree to traverse<a name="line.88"></a>
<FONT color="green">089</FONT>             * @return true if traversing should be continued<a name="line.89"></a>
<FONT color="green">090</FONT>             */<a name="line.90"></a>
<FONT color="green">091</FONT>            boolean enterIfCandidates(T token, Node&lt;T&gt; nodeA, Node&lt;T&gt; nodeB);<a name="line.91"></a>
<FONT color="green">092</FONT>            /**<a name="line.92"></a>
<FONT color="green">093</FONT>             * Leave this traversing step, counterpart to <a name="line.93"></a>
<FONT color="green">094</FONT>             * {@link #enterIfCandidates(Object, Node, Node)}. Frees resources that <a name="line.94"></a>
<FONT color="green">095</FONT>             * might have been allocated for this recursion level.<a name="line.95"></a>
<FONT color="green">096</FONT>             *  <a name="line.96"></a>
<FONT color="green">097</FONT>             * @param token         the traversing token<a name="line.97"></a>
<FONT color="green">098</FONT>             * @param nodeA         node of the first tree to traverse<a name="line.98"></a>
<FONT color="green">099</FONT>             * @param nodeB         node of the second tree to traverse<a name="line.99"></a>
<FONT color="green">100</FONT>             */<a name="line.100"></a>
<FONT color="green">101</FONT>            void leave(T token, Node&lt;T&gt; nodeA, Node&lt;T&gt; nodeB);<a name="line.101"></a>
<FONT color="green">102</FONT>            <a name="line.102"></a>
<FONT color="green">103</FONT>            /**<a name="line.103"></a>
<FONT color="green">104</FONT>             * Returns true if the given &lt;code&gt;count&lt;/code&gt; is at least the minimum <a name="line.104"></a>
<FONT color="green">105</FONT>             * required zero bit count needed for adjacency<a name="line.105"></a>
<FONT color="green">106</FONT>             * <a name="line.106"></a>
<FONT color="green">107</FONT>             * @param token         the traversing token<a name="line.107"></a>
<FONT color="green">108</FONT>             * @param count         the count to test<a name="line.108"></a>
<FONT color="green">109</FONT>             * @return true if &lt;code&gt;count&lt;/code&gt; is sufficiently large<a name="line.109"></a>
<FONT color="green">110</FONT>             */<a name="line.110"></a>
<FONT color="green">111</FONT>            boolean isRequiredZeroBitCount(T token, int count);<a name="line.111"></a>
<FONT color="green">112</FONT>    }<a name="line.112"></a>




























































</PRE>
</BODY>
</HTML>
